
#include <stdio.h>
#include <string.h>
#include <defs.h>
#include <sdklib.h>
#include <ft812.h>
#include <ft812lib.h>
#include <ts.h>
#include <tslib.h>
#include <pff.h>
#include <diskio.h>

u8 pcx, pcx0, pcy, pca, pcst;

#include "zifi.c"

void putchar(u8 b)
{
  if (pcst == 1)                           // ink argument
  {
    pca = ((b > '9') ? (b - 7) : b) - '0';
    pcst = 0;
  }
  else                                    // character
  {
    if (b == '\r')                        // CR
      pcx = pcx0;
    else if (b == '\n')                   // LF
    {
      pcy++;
      if (pcy >= 36) pcy = 0;
    }
    else if (b == '\a')                   // ink
      pcst = 1;
    else                                  // draw char
    {
      u8 *a = (u8*)0xC000;
      u16 o = (pcy << 8) + (pcx & 127);
      a[o] = b;
      a[o ^ 128] = pca;
      pcx++;
      if (pcx >= 90)
      {
        putchar('\r');
        putchar('\n');
      }
    }
  }
}

u8 i;

void main()
{
  pcy = pcx = pcx0 = pcst = 0;

  // ts_wreg(TS_SYSCONFIG, 6);

  ts_wreg(TS_VCONFIG, 0xC3);
  ts_wreg(TS_VPAGE, 0xF6);
  ts_wreg(TS_PAGE3, 0xF6);

  // ts_wreg(TS_FMADDR, TS_FM_EN + 0xC);
  // *(u16*)(0xC1E2) = 32768 + 4096 + 128 + 4;
  // ts_wreg(TS_FMADDR, 0);
  // ts_wreg(TS_BORDER, 1);

  memset((u8*)0xC000, 0, 0x4000);

  zf_wr(ZF_CR, 0x03); // clear FIFOs
  zf_wr(ZF_CR, 0xF1); // set API=1
  zf_wr(ZF_CR, 0xFF); // get max API
  zf_wr(ZF_ZIBTR, 8);
  zf_wr(ZF_ZITOR, 2);
  ts_wreg(TS_INTMASK, TS_INT_MSK_WTP);
  
  // printf("\aEAPI: \aC%02X\r\n", zf_rd(ZF_ER));
  // printf("\aEOFR: \aC%02X\r\n", zf_rd(ZF_OFR));

  // zf_at_raw("AT+CWQAP\r\n"); zf_resp();
  // zf_at_raw("ATE0\r\n"); zf_resp();
  // zf_at_raw("AT+GMR\r\n"); zf_resp();
  // zf_at_raw("AT+CWMODE=1\r\n"); zf_resp();
  // zf_at_raw("AT+CWAUTOCONN=0\r\n"); zf_resp();
  // zf_at_raw("AT+CIPMUX=0\r\n"); zf_resp();
  // zf_at_raw("AT+CWJAP=\"TS-Home\",\"tRu57n0fckn1\"\r\n"); zf_wait(200000); zf_resp();
  // zf_at_raw("AT+CIPSTART=\"TCP\",\"tslabs.info\",80\r\n"); zf_resp();
  // zf_at_raw("AT+CIPSEND=43\r\n"); zf_resp();
  // zf_at_raw("GET /ip.php HTTP/1.1\r\nHost: tslabs.info\r\n\r\n"); zf_resp();

  // ts_wreg(TS_VCONFIG, 0xC2);
  // ts_wreg(TS_VPAGE, 0x80);

  // {
    // u8 p;
    // for (p = 0x80; p < 0x90; p++)
    // {
      // ts_wreg(TS_PAGE3, p);
      // memset((void*)0xc000, 0, 16384);
    // }
  // }
  // ts_wreg(TS_PAGE3, 0x80);

  asm(ei);
  
  while (1)
  {
    u8 c;
    u8 b[256];
    zf_wr(ZF_IMR, ZF_IMR_ZITO);
    asm(halt);
    c = zf_rd(ZF_ZIFR);
    zf_rd_fifo(b, c);
    b[c] = 0;
    printf("\aF%02X, %02X, %s\r\n", c, zf_rd(ZF_ISR), b);
  }
}

/*
l1:
  memset((u8*)0xC000, 1, 0x4000); pcx = pcy = 0;
  // zf_at_raw("AT\r\n");
  zf_at_raw("AT+GMR\r\n");
  // zf_at_raw("AT+CIPSEND=46\r\n"); zf_resp();
  // zf_at_raw("GET /test1.bin HTTP/1.1\r\nHost: tslabs.info\r\n\r\n");
  // zf_resp();
  zf_resp2();
  anykey();
  goto l1;
  while (1);
*/
